/* netproto.h: network protocol definitions */

#ifndef NETPROTO_H
#define NETPROTO_H

/* default port */

#define DEFAULT_PORT 8128

/* environment variable possibly containing remote host:remote port */

#define ENV_NAME "NETAUDIOHOST"

/* files to forward; end with NULL */
/* audio-cd is not available yet, its ioctls are missing */

#define FWD_FILES \
  { "/dev/audio", "/dev/dsp", "/dev/mixer", NULL }

/* functions to be forwarded */
#define CALL_OPEN     1 
#define CALL_CLOSE    2
#define CALL_WRITE    3
#define CALL_READ     4
#define CALL_IOCTL    5
#define CALL_LSEEK    6

/* some symbols exported by libc */
extern int __libc_write (int, const void *, unsigned);
extern int __libc_read  (int, void *, unsigned);

/* some basic I/O functions */

void lookup_server(char *host, int port, struct sockaddr_in *saddr);
int connect_to_server(struct sockaddr_in *saddr);

int send_string(int sock, const char *s);
int send_int(int sock, int i);
int recv_string(int sock, char **s);
int recv_int(int sock, int *i);
int send_data(int sock, unsigned int len, const char *s);
int recv_data(int sock, unsigned int len, char *s);
int flush_send(int sock);

#endif /* NETPROTO_H */
